﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Services;
using System.Data.SqlClient;

/// <summary>
/// Summary description for AnnouncementService
/// </summary>
[WebService(Namespace = "http://msis.myvnc.com/webservices/")]
[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
// To allow this Web Service to be called from script, using ASP.NET AJAX, uncomment the following line. 
// [System.Web.Script.Services.ScriptService]
public class AnnouncementService : System.Web.Services.WebService {

    public AnnouncementService () {

        //Uncomment the following line if using designed components 
        //InitializeComponent(); 
    }

    [WebMethod]
    public Announcement[] GetAnnouncements(string username) {

        List<Announcement> announcements = new List<Announcement>();
        
        // TODO: query DB for announcements for username

        try
        {
            SQLConn.Open();
            string sqlQuery =
                   "SELECT Announcements.* FROM Announcements " +
                   "INNER JOIN Announcements_Users ON Announcements.id = Announcements_Users.announcement_id " +
                   "INNER JOIN Users ON Announcements_Users.user_id = Users.id " +
                   "WHERE Users.username = '" + username + "' " +
                   "ORDER BY Announcements.date DESC";

            SqlCommand cmd = SQLConn.ExecuteCommand(sqlQuery);
            SqlDataReader reader = cmd.ExecuteReader();
            while (reader.Read())
            {
                Announcement a = new Announcement();
                a.Category = (Announcement.AnnouncementCategory)Int32.Parse(reader["category"].ToString());
                a.Title = (string)reader["title"];
                a.Text = (string)reader["text"];
                a.DateAdded = Convert.ToDateTime(reader["date"].ToString());
                announcements.Add(a);
            }
            reader.Close();
            SQLConn.Close();
        }
        catch (Exception e)
        {
            Logger.WriteLog(e.Message, false);
        }

        return (announcements.Count > 0) ? announcements.ToArray() : null;
    }
    
}

