﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="Default.aspx.cs" Inherits="_Default" Debug="true" %>

<%@ Register assembly="AjaxControlToolkit" namespace="AjaxControlToolkit" tagprefix="cc1" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>MSIS Administration Panel</title>
    <link rel="Stylesheet" type="text/css" href="style.css" media="screen" />
    <script type="text/javascript" language="javascript">
    <!--
        function clearText(textbox) {
            if (textbox.value == textbox.getAttribute('infotext')) {
                textbox.value = '';
            }
        }

        function resetText(textbox) {
            if (textbox.value == '') {
                textbox.value = textbox.getAttribute('infotext');
            } 
        }
    // -->
    </script>
</head>
<body>
    
<form id="form1" runat="server">
<asp:ScriptManager ID="ScriptManager1" runat="server"></asp:ScriptManager>
<asp:MultiView ID="multiView" runat="server" EnableViewState="true">
    <asp:View ID="loginView" runat="server">
        <div id="container" style="width:400px">
        <div id="main">
        <h1>MSIS Administration Panel: Login</h1>
        <h2>Please log in with your username and password below.</h2>
        <table>
        <tr>
          <th style="width:100px">Username:</th>
          <td><asp:TextBox ID="txtUsername" runat="server" CssClass="txtInput2"></asp:TextBox></td>
        </tr>
        <tr>
          <th>Password:</th>
          <td><asp:TextBox ID="txtPassword" runat="server" TextMode="Password" CssClass="txtInput2"></asp:TextBox></td>
        </tr>
        <tr>
          <td><asp:Button ID="btnLogin" runat="server" Text="Log In" onclick="btnLogin_Click" /></td>
          <td><asp:Label ID="lblLoginMessage" runat="server" Text="" CssClass="error-message"></asp:Label></td>
        </tr>
        </table>
        </div>
        <p class="credits">Design &amp; Development: Sindre Paulsrud Moe</p>
        </div>
    </asp:View>
    <asp:View ID="mainView" runat="server" OnActivate="PopulateForm">
        <div id="container">
        <div id="main">
        <h1>User Profile</h1>
        <p>
        <asp:LinkButton ID="logout" runat="server" OnClientClick="return confirm('Do you really want to log out?');" onclick="btnLogOut_Click">Log Out</asp:LinkButton> |
        <asp:LinkButton ID="editProfile" CssClass="selectedLink" runat="server">Edit User Profile</asp:LinkButton>
        </p>
        <h2>
        Edit your profile below. To add courses to your profile, type in a course code or course title in the text box, and suggestions will appear automatically. 
        If you have optional subjects which are outside your study program, check the "Outside study program?" option.
        </h2>
        <table>
        <tr>
          <th style="width:100px">Full name:</th>
          <td>
          <input id="userId" type="hidden" runat="server" />
          <asp:TextBox ID="txtFullNameChange" runat="server" CssClass="txtInput"></asp:TextBox>
          </td>
        </tr>
        <tr>
          <th>Username:</th>
          <td><asp:TextBox ID="txtUsernameChange" runat="server" CssClass="txtInput"></asp:TextBox></td>
        </tr>
        <tr>
          <th>Email:</th>
          <td><asp:TextBox ID="txtEmailChange" runat="server" CssClass="txtInput"></asp:TextBox></td>
        </tr>
        <tr>
          <th>Password:</th>
          <td>
          <asp:TextBox ID="txtPasswordChange" runat="server" TextMode="Password" CssClass="txtInput"></asp:TextBox> (leave empty for no change)</td>
        </tr>
        <tr>
          <th>Study program:</th>
          <td>
          <asp:TextBox ID="txtStudyProgramChange" runat="server" CssClass="txtInput"></asp:TextBox> (optional)
          <asp:Panel ID="panelStudyProgramDropdown" runat="server" ScrollBars="Vertical" Height="125px" />
          <cc1:AutoCompleteExtender ID="txtStudyProgramChange_AutoCompleteExtender" 
              runat="server" DelimiterCharacters="" Enabled="True"
              ServicePath="http://msis.myvnc.com/webservices/ScheduleService.asmx"
              ServiceMethod="GetStudyProgramList"
              TargetControlID="txtStudyProgramChange"
              MinimumPrefixLength="1"
              EnableCaching="true"
              FirstRowSelected="true"
              CompletionInterval="50"
              CompletionSetCount="10"
              CompletionListElementID="panelStudyProgramDropdown"
              CompletionListItemCssClass="autocomplete-item"
              CompletionListHighlightedItemCssClass="autocomplete-item-highlighted">
          </cc1:AutoCompleteExtender>
          </td>
        </tr>
        <tr>
          <th>Semester:</th>
          <td><asp:TextBox ID="txtSemesterChange" runat="server" CssClass="txtInput"></asp:TextBox></td>
        </tr>
        <tr>
          <th rowspan="2" valign="baseline">Courses:</th>
          <td valign="baseline">
          <asp:TextBox ID="txtSearchCourses" runat="server" CssClass="txtInput" Text="Type a course code or subject title..."></asp:TextBox>
          
          <asp:Panel ID="panelCourseDropdown" runat="server" ScrollBars="Vertical" Height="150px" />
          <cc1:AutoCompleteExtender ID="txtSearchCourses_AutoCompleteExtender" 
              runat="server" DelimiterCharacters="" Enabled="True"
              ServicePath="http://msis.myvnc.com/webservices/ScheduleService.asmx"
              ServiceMethod="GetCourseList"
              TargetControlID="txtSearchCourses"
              MinimumPrefixLength="1"
              EnableCaching="true"
              FirstRowSelected="true"
              CompletionInterval="50"
              CompletionSetCount="10"
              CompletionListElementID="panelCourseDropdown"
              CompletionListItemCssClass="autocomplete-item"
              CompletionListHighlightedItemCssClass="autocomplete-item-highlighted">
          </cc1:AutoCompleteExtender>
          <asp:CheckBox ID="chkboxOutsideStudyprogram" runat="server" /> <label for="chkboxOutsideStudyprogram">Outside study program?</label><br />
          <asp:LinkButton ID="btnAddCourse" runat="server" onclick="addCourseToList">Add course</asp:LinkButton></td>
          </td>
        </tr>
        <tr>
          <td valign="baseline">
          <div style="float:left">
          <asp:ListBox ID="listCourseCodesChange" runat="server" Width="330" 
                  SelectionMode="Multiple" DataTextField="Description" DataValueField="Code" 
                  AppendDataBoundItems="false" ondatabound="listCourseCodesChange_DataBound"></asp:ListBox>
          </div>
          <div style="float:left;margin-left:5px;width:200px">
          To remove a course, select one or more items in the list to the left and click on "Remove".<br />
          <asp:Button ID="btnRemoveCourse" runat="server" Text="Remove" 
                  onclick="removeCourseFromList" />
          </div>
          </td>
        </tr>
        <tr>
          <td><asp:Button ID="btnSave" runat="server" onclick="btnSave_Click" Text="Save profile" />
        </td>
          <td><asp:Label ID="lblStatusMessage" runat="server" Text="" CssClass="error-message"></asp:Label></td>
        </tr>
        </table>
       </div>
       <p class="credits">Design &amp; Development: Sindre Paulsrud Moe</p>
       </div>
    </asp:View>
</asp:MultiView>
</form>
</body>
</html>
