﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

/// <summary>
/// Summary description for Announcement
/// </summary>
public class Announcement
{
    public enum AnnouncementCategory { Deadline = 0, General, Other };

    string title;
    string text;
    AnnouncementCategory category;
    DateTime dateAdded;

    public Announcement()
    {
        //
        // TODO: Add constructor logic here
        //
    }

	public Announcement(AnnouncementCategory category)
	{
        this.category = category;
	}

    public string Title
    {
        get { return title; }
        set { title = value; }
    }
    public string Text
    {
        get { return text; }
        set { text = value; }
    }
    public AnnouncementCategory Category
    {
        get { return category; }
        set { category = value; }
    }
    public DateTime DateAdded
    {
        get { return dateAdded; }
        set { dateAdded = value; }
    }
}
