﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace MSIS
{
    public partial class Configuration : Form
    {
        public Configuration()
        {
            InitializeComponent();
        }

        private void Configuration_Load(object sender, EventArgs e)
        {
            if (AppSettings.ConfigFileExists)
            {
                txtWebServicesURL.Text = AppSettings.WebServiceUrl;
                txtMapURL.Text = AppSettings.MapUrl;
                radioShowTooltip.Checked = AppSettings.ShowHints;
                radioDontShowTooltip.Checked = !AppSettings.ShowHints;
            }
        }

        private void menuItemSave_Click(object sender, EventArgs e)
        {
            AppSettings.Create();
            AppSettings.WebServiceUrl = txtWebServicesURL.Text;
            AppSettings.MapUrl = txtMapURL.Text;
            AppSettings.ShowHints = radioShowTooltip.Checked;
            MessageBox.Show("Settings successfully saved!", "Success",
                MessageBoxButtons.OK, MessageBoxIcon.Asterisk, MessageBoxDefaultButton.Button1);
        }

        private void menuItemExit_Click(object sender, EventArgs e)
        {
            Close();
        }

    }
}